# Typing with React

In order to encourage people to support my work I've decided to publish a TLDR; version of this chapter to the community. This will allow me to develop more content, so it's a win-win really.

You can access the full chapter by buying a copy through [Leanpub](https://leanpub.com/survivejs_webpack_react). It goes into detail, whereas the following should give you a rough idea of the chapter contents.

## TLDR;

* [propTypes](https://facebook.github.io/react/docs/reusable-components.html) are great. Use them to improve the maintainability of your application.
* `propTypes` give you nice little errors during development, but will be stripped from the production build to improve performance.
* [Flow](http://flowtype.org) goes one step further. It provides syntax that allows you to gradually type your JavaScript code.
* As Flow output can be cryptic to read, [flowery](https://github.com/coodoo/flowery) formats it in a nicer way.
* While `flow` itself is a static checker you have to run separately, [babel-plugin-typecheck](https://github.com/codemix/babel-plugin-typecheck) provides runtime checks during development.
* Microsoft's [TypeScript](http://www.typescriptlang.org/) is yet another alternative. Starting from the version 1.6 it will gain JSX support.

> [Buy the book](https://leanpub.com/survivejs_webpack_react) for the rest.
